> For the complete documentation index, see [llms.txt](https://docs.opshub.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.opshub.com/upcoming-release/mbse-connector-sdk-index/mbse-sdk-connector-apis/metadata-apis/workspaces-list.md).

# Get All Workspaces

## Overview

Get the workspaces from the end system that the integration user has access to.

> **Note**: Return the empty list if the end system does not have the Workspaces' structure.

## API URI

This is the URI OpsHub will execute to call this API:

```bash
GET: /mbse/api/1.0/workspaces?
    startIndex=<startIndex>
    maxResults=<maxResults>
```

## URI Parameters

| Name       | In    | Required | Type    | Description                                                                               |
| ---------- | ----- | -------- | ------- | ----------------------------------------------------------------------------------------- |
| startIndex | Query | True     | Integer | Start index from which list of workspaces should be returned                              |
| maxResults | Query | True     | Integer | Maximum number of workspaces to be returned by custom connector, starting from startIndex |

## Response Payload

```json
[
  {
    "id": "unique identifier",
    "name": "project name",
    "parentWorkSpaceId": "parent workspace id"
  }
]
```

| Name              | Type              | Required | Description                                                                                            |
| ----------------- | ----------------- | -------- | ------------------------------------------------------------------------------------------------------ |
| id                | Integer or String | True     | Id or internal name of the workspace                                                                   |
| name              | String            | True     | Display name of the workspace                                                                          |
| parentWorkSpaceId | String            | False    | If end system supports workspace hierarchy, set the id or internal name of the direct parent workspace |

## Examples

### Flat workspace list

**Example 1:**

```json
[
  {
    "id": "1",
    "name": "Sample Workspace",
    "parentWorkSpaceId": ""
  },
  {
    "id": "2",
    "name": "Demo Workspace",
    "parentWorkSpaceId": ""
  }
]
```

### Example 2

```json
[
  {
    "id": "SAMP",
    "name": "Sample Workspace",
    "parentWorkSpaceId": ""
  },
  {
    "id": "DEMO",
    "name": "Demo Workspace",
    "parentWorkSpaceId": ""
  }
]
```

### Workspace hierarchy

```json
[
  {
    "id": "ws-11",
    "name": "Main Child Workspace",
    "parentWorkSpaceId": "ws-1"
  },
  {
    "id": "ws-12",
    "name": "Sample Workspace",
    "parentWorkSpaceId": "ws-1"
  },
  {
    "id": "ws-21",
    "name": "Demo Workspace",
    "parentWorkSpaceId": "ws-2"
  },
  {
    "id": "ws-22",
    "name": "Trial Workspace",
    "parentWorkSpaceId": "ws-3"
  }
]

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.opshub.com/upcoming-release/mbse-connector-sdk-index/mbse-sdk-connector-apis/metadata-apis/workspaces-list.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
